

// programme avec mesure sur A0 et sortie D4 commandant mosfet ou relais (attention si relais, la commande peut être inversée suivant si NC ou NO)

//Fonction millis() utilisée pour mesurer le temps

unsigned long millis();

//variables pour gestion du temps

float temps = 0;
unsigned long ecart;
unsigned long tempsms;
unsigned long lastTime;

// variable pour la commande
boolean commande;


float consigne;

float temperature, tension;
int mesure;
unsigned long int avgValue;
int buf[20], temp;


// Boucle Setup pour indiquer le port de communication
void setup()   {
  Serial.begin(9600);
  commande = 1;           // on initialise la commande à O. On ne chauffe pas avant d'avoir la température
  consigne = 35,00;     // température de consigne

  analogReference(INTERNAL);  // notre tension de référence interne sera de 1.1V
  pinMode(4, OUTPUT);         //On utilisera D4 pour commander le relais
  pinMode(A0, INPUT);         //L'entrée analogique A0 mesurera la tension issue du capteur de température
  digitalWrite(4, commande);
  Serial.print("Temps(s) "); Serial.print(";"); Serial.println("Température (°C)");


  lastTime = millis(); //On initialise le chrono
}


void loop()
{
  // Gestion du temps
  
  ecart = millis() - lastTime; //mesure du temps depuis la dernière mesure en millisecondes
  if (ecart > 1000) {     //Si une seconde est passée depuis la dernière mesure
    lastTime = millis(); //on réinitialise le chrono à 0
    tempsms = (tempsms + ecart); //valeur du chronomètre en ms

    // gestion des mesures
    for (int i = 0; i < 20; i++) // On effectue 20 mesures toutes les 10 ms qu'on stocke dans un tableau
    {
      buf[i] = analogRead(A0);
      delay(10);
    }
    for (int i = 0; i < 19; i++) //Range les valeurs de la plus petite à la plus grande dans le tableau
    {
      for (int j = i + 1; j < 19; j++)
      {
        if (buf[i] > buf[j])
        {
          temp = buf[i];
          buf[i] = buf[j];
          buf[j] = temp;
        }
      }
    }
    
    avgValue = 0;
    for (int i = 6; i < 14; i++) // On fait la moyenne des 8 mesures médianes
    avgValue += buf[i];
    tension = (float)avgValue * 1.1 / 1024 / 8; // Calcul de la tension moyenne associée à ces mesures

    temperature = tension * 100/2;            // On multiplie par 100 car on a 10 mV/°C au départ on divise par 2 à cause de l'ampli 

    temps = tempsms / 1000;             // Calcul du temps écoulé en seconde
    
    Serial.print(temps); Serial.print(";"); Serial.println(temperature); //on affiche le temps et la température séparées par un point virgule pour exporter facilement
    // sous regressi
    
    // gestion de la commande comparateur
    
    if (consigne > temperature) {
      commande = 1;               
       Serial.println("On chauffe");                         }
    else {
      commande = 0;
          }
    digitalWrite(4, commande);


  }
}
